/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.advisorapp;

import java.util.List;
import org.springframework.ai.chat.client.ChatClient;
import org.springframework.ai.chat.client.advisor.SafeGuardAdvisor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 *
 * @author omozegieaziegbe
 */
@RestController
public class LearningController {

    private final ChatClient chatClient;

    public LearningController(ChatClient.Builder chatClient) {
        // Define forbidden topics or terms
        List<String> forbiddenTopics = List.of("violence", "hate speech", "illegal activities");
        
        // Configure SafeGuardAdvisor with a custom message and priority
        SafeGuardAdvisor safeGuardAdvisor = new SafeGuardAdvisor(
            forbiddenTopics, 
            "I'm sorry, I cannot assist with that topic.", 
            1
        );
        
        // Initialize ChatClient with the SafeGuardAdvisor
        this.chatClient = chatClient.defaultAdvisors(safeGuardAdvisor).build();
    }

    // Expose an endpoint to interact with the chat model
    @GetMapping("/ask")
    public String askAI(
        @RequestParam(value = "question", defaultValue = "What are the basics of AI?") String question
    ) {
        return this.chatClient.prompt()
                              .user(question)
                              .call()
                              .content();
    }
    
    
}
